Index: Makefile
===================================================================
--- Makefile	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ Makefile	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -126,2 +126,7 @@
 ctags: 
 	ctags `find . -name "*.c"` `find . -name "*.h"`
+
+# Using this as a bogus Make target to test if a GNU-compatible version of
+# make is available.
+helloworld:
+	@echo Hello World
Index: bitlbee.c
===================================================================
--- bitlbee.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ bitlbee.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -36,4 +36,41 @@
 static gboolean bitlbee_io_new_client( gpointer data, gint fd, b_input_condition condition );
 
+static gboolean try_listen( struct addrinfo *res )
+{
+	int i;
+	
+	global.listen_socket = socket( res->ai_family, res->ai_socktype, res->ai_protocol );
+	if( global.listen_socket < 0 )
+	{
+		log_error( "socket" );
+		return FALSE;
+	}
+
+#ifdef IPV6_V6ONLY		
+	if( res->ai_family == AF_INET6 )
+	{
+		i = 0;
+		setsockopt( global.listen_socket, IPPROTO_IPV6, IPV6_V6ONLY,
+		            (char *) &i, sizeof( i ) );
+	}
+#endif
+
+	/* TIME_WAIT (?) sucks.. */
+	i = 1;
+	setsockopt( global.listen_socket, SOL_SOCKET, SO_REUSEADDR, &i, sizeof( i ) );
+
+	i = bind( global.listen_socket, res->ai_addr, res->ai_addrlen );
+	if( i == -1 )
+	{
+		closesocket( global.listen_socket );
+		global.listen_socket = -1;
+		
+		log_error( "bind" );
+		return FALSE;
+	}
+	
+	return TRUE;
+}
+
 int bitlbee_daemon_init()
 {
@@ -42,6 +79,6 @@
 	FILE *fp;
 	
-	log_link( LOGLVL_ERROR, LOGOUTPUT_SYSLOG );
-	log_link( LOGLVL_WARNING, LOGOUTPUT_SYSLOG );
+	log_link( LOGLVL_ERROR, LOGOUTPUT_CONSOLE );
+	log_link( LOGLVL_WARNING, LOGOUTPUT_CONSOLE );
 	
 	memset( &hints, 0, sizeof( hints ) );
@@ -63,25 +100,16 @@
 
 	global.listen_socket = -1;
-
+	
+	/* Try IPv6 first (which will become an IPv6+IPv4 socket). */
 	for( res = addrinfo_bind; res; res = res->ai_next )
-	{
-		global.listen_socket = socket( res->ai_family, res->ai_socktype, res->ai_protocol );
-		if( global.listen_socket < 0 )
-			continue;
-
-		/* TIME_WAIT (?) sucks.. */
-		i = 1;
-		setsockopt( global.listen_socket, SOL_SOCKET, SO_REUSEADDR, &i, sizeof( i ) );
-
-		i = bind( global.listen_socket, res->ai_addr, res->ai_addrlen );
-		if( i == -1 )
-		{
-			log_error( "bind" );
-			return( -1 );
-		}
-
-		break;
-	}
-
+		if( res->ai_family == AF_INET6 && try_listen( res ) )
+			break;
+	
+	/* The rest (so IPv4, I guess). */
+	if( res == NULL )
+		for( res = addrinfo_bind; res; res = res->ai_next )
+			if( res->ai_family != AF_INET6 && try_listen( res ) )
+				break;
+	
 	freeaddrinfo( addrinfo_bind );
 
@@ -107,4 +135,5 @@
 			exit( 0 );
 		
+		setsid();
 		chdir( "/" );
 		
@@ -137,4 +166,10 @@
 #endif
 	
+	if( !global.conf->nofork )
+	{
+		log_link( LOGLVL_ERROR, LOGOUTPUT_SYSLOG );
+		log_link( LOGLVL_WARNING, LOGOUTPUT_SYSLOG );
+	}
+	
 	return( 0 );
 }
Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ bitlbee.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -35,6 +35,8 @@
 
 #define PACKAGE "BitlBee"
-#define BITLBEE_VERSION "1.2.5"
+#define BITLBEE_VERSION "1.2.6a"
 #define VERSION BITLBEE_VERSION
+#define BITLBEE_VER(a,b,c) (((a) << 16) + ((b) << 8) + (c))
+#define BITLBEE_VERSION_CODE BITLBEE_VER(1, 2, 6)
 
 #define MAX_STRING 511
Index: conf.c
===================================================================
--- conf.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ conf.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -82,5 +82,5 @@
 	}
 	
-	while( argc > 0 && ( opt = getopt( argc, argv, "i:p:P:nvIDFc:d:hR:u:" ) ) >= 0 )
+	while( argc > 0 && ( opt = getopt( argc, argv, "i:p:P:nvIDFc:d:hR:u:V" ) ) >= 0 )
 	/*     ^^^^ Just to make sure we skip this step from the REHASH handler. */
 	{
@@ -148,5 +148,12 @@
 			        "  -d  Specify alternative user configuration directory\n"
 			        "  -x  Command-line interface to password encryption/hashing\n"
-			        "  -h  Show this help page.\n" );
+			        "  -h  Show this help page.\n"
+			        "  -V  Show version info.\n" );
+			return NULL;
+		}
+		else if( opt == 'V' )
+		{
+			printf( "BitlBee %s\nAPI version %06x\n",
+			        BITLBEE_VERSION, BITLBEE_VERSION_CODE );
 			return NULL;
 		}
Index: configure
===================================================================
--- configure	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ configure	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -26,4 +26,5 @@
 oscar=1
 yahoo=1
+twitter=1
 purple=0
 
@@ -67,4 +68,5 @@
 --oscar=0/1	Disable/enable Oscar part (ICQ, AIM)	$oscar
 --yahoo=0/1	Disable/enable Yahoo part		$yahoo
+--twitter=0/1 Disable/enable Twitter part		$twitter
 
 --purple=0/1	Disable/enable libpurple support	$purple
@@ -270,5 +272,5 @@
 detect_ldap()
 {
-	TMPFILE=$(mktemp)
+	TMPFILE=$(mktemp /tmp/bitlbee-configure.XXXXXX)
 	if $CC -o $TMPFILE -shared -lldap 2>/dev/null >/dev/null; then
 		cat<<EOF>>Makefile.settings
@@ -298,5 +300,5 @@
 detect_resolv_dynamic()
 {
-	TMPFILE=$(mktemp)
+	TMPFILE=$(mktemp /tmp/bitlbee-configure.XXXXXX)
 	ret=1
 	echo "$RESOLV_TESTCODE" | $CC -o $TMPFILE -x c - -lresolv >/dev/null 2>/dev/null
@@ -312,5 +314,5 @@
 detect_resolv_static()
 {
-	TMPFILE=$(mktemp)
+	TMPFILE=$(mktemp /tmp/bitlbee-configure.XXXXXX)
 	ret=1
 	for i in $systemlibdirs; do
@@ -479,4 +481,18 @@
 fi
 
+if ! make helloworld > /dev/null 2>&1; then
+	echo "WARNING: Your version of make (BSD make?) does not support BitlBee's makefiles."
+	echo "BitlBee needs GNU make to build properly. On most systems GNU make is available"
+	echo "under the name 'gmake'."
+	echo
+	if gmake helloworld > /dev/null 2>&1; then
+		echo "gmake seems to be available on your machine, great."
+		echo
+	else
+		echo "gmake is not installed (or not working). Please try to install it."
+		echo
+	fi
+fi
+
 cat <<EOF>bitlbee.pc
 prefix=$prefix
@@ -551,4 +567,12 @@
 fi
 
+if [ "$twitter" = 0 ]; then
+	echo '#undef WITH_TWITTER' >> config.h
+else
+	echo '#define WITH_TWITTER' >> config.h
+	protocols=$protocols'twitter '
+	protoobjs=$protoobjs'twitter_mod.o '
+fi
+
 if [ "$protocols" = "PROTOCOLS = " ]; then
 	echo "Warning: You haven't selected any communication protocol to compile!"
Index: debian/bitlbee.init
===================================================================
--- debian/bitlbee.init	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ debian/bitlbee.init	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -38,6 +38,6 @@
 d_start() {
 	# Make sure BitlBee can actually write its PID...
-	touch /var/run/bitlbee.pid
-	chown bitlbee: /var/run/bitlbee.pid
+	touch $PIDFILE
+	chown bitlbee: $PIDFILE
 	
 	start-stop-daemon --start --quiet --pidfile $PIDFILE \
Index: debian/changelog
===================================================================
--- debian/changelog	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ debian/changelog	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -1,2 +1,11 @@
+bitlbee (1.2.6a-1) unstable; urgency=low
+
+  * New upstream version.
+  * Native support for Twitter.
+  * Fixed /WHOIS response format. (Closes: #576120)
+  * Problems with bitlbee-skype are solved by now. (Closes: #575572)
+
+ -- Wilmer van der Gaast <wilmer@peer.gaast.net>  Tue, 20 Apr 2010 00:34:51 +0200
+
 bitlbee (1.2.5-1) unstable; urgency=low
 
Index: debian/rules
===================================================================
--- debian/rules	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ debian/rules	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -100,5 +100,5 @@
 		find usr -type f -exec md5sum {} \; > DEBIAN/md5sums
 
-	dpkg-gencontrol -ldebian/changelog -isp -pbitlbee-dev -Pdebian/bitlbee-dev
+	dpkg-gencontrol -ldebian/changelog -isp -pbitlbee-dev -Pdebian/bitlbee-dev -v1:$(BITLBEE_VERSION)-0
 
 	dpkg --build debian/bitlbee-dev ..
Index: doc/CHANGES
===================================================================
--- doc/CHANGES	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ doc/CHANGES	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -3,4 +3,31 @@
 
 http://bugs.bitlbee.org/bitlbee/timeline?daysback=90&changeset=on
+
+Version 1.2.6a:
+- Fixed a typo that renders the Twitter groupchat mode unusable. A last-
+  minute change that came a few minutes late.
+
+Finished 19 Apr 2010
+
+Version 1.2.6:
+- Native (very basic) support for Twitter, implemented by Geert Mulders.
+  Currently supported are posting tweets, reading the ones of people you
+  follow, and sending (not yet receiving!) direct messages.
+- Fixed format of status messages in /WHOIS to improve IRC client
+  compatibility.
+- Show timestamps of offline messages/channel backlogs.
+- Allow saving MSN display names locally since sometimes this stuff breaks
+  server-side. (Use the local_display_name per-account setting.)
+- Suppress empty "Headline:" messages for certain new XMPP broadcast 
+  messages.
+- Better handling of XMPP contacts with multiple resources on-line. Default
+  behaviour now is to write to wherever the last message came from, or to
+  the bare JID (usually becomes a broadcast) if there wasn't any recent msg.
+- Added a switchboard_keepalives setting which should solve some issues with
+  talking to offline MSN contacts. (Although full support for offline
+  messages is not ready yet!)
+- The usual misc. bug fixes.
+
+Finished 19 Apr 2010
 
 Version 1.2.5:
@@ -23,5 +50,5 @@
   the main client).
 
-Fixed 17 Mar 2010
+Finished 17 Mar 2010
 
 Version 1.2.4:
Index: doc/user-guide/commands.xml
===================================================================
--- doc/user-guide/commands.xml	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ doc/user-guide/commands.xml	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -21,5 +21,5 @@
 			<description>
 				<para>
-					Adds an account on the given server with the specified protocol, username and password to the account list. Supported protocols right now are: Jabber, MSN, OSCAR (AIM/ICQ) and Yahoo. For more information about adding an account, see <emphasis>help account add &lt;protocol&gt;</emphasis>.
+					Adds an account on the given server with the specified protocol, username and password to the account list. Supported protocols right now are: Jabber, MSN, OSCAR (AIM/ICQ), Yahoo and Twitter. For more information about adding an account, see <emphasis>help account add &lt;protocol&gt;</emphasis>.
 				</para>
 			</description>
@@ -63,4 +63,22 @@
 				</ircexample>
 			</bitlbee-command>
+			
+			<bitlbee-command name="twitter">
+				<syntax>account add twitter &lt;handle&gt; &lt;password&gt;</syntax>
+
+				<description>
+					<para>
+						This module gives you simple access to Twitter. Although it uses the Twitter API, only Twitter itself is supported at the moment.
+					</para>
+					
+					<para>
+						By default all your Twitter contacts will come from a contact called twitter_(yourusername). You can change this behaviour using the <emphasis>mode</emphasis> setting (see <emphasis>help set mode</emphasis>).
+					</para>
+					
+					<para>
+						To send tweets yourself, send them to the twitter_(yourusername) contact, or just write in the groupchat channel if you enabled that option.
+					</para>
+				</description>
+			</bitlbee-command>
 
 			<bitlbee-command name="yahoo">
@@ -401,5 +419,5 @@
 
 	<bitlbee-setting name="auto_reconnect" type="boolean" scope="both">
-		<default>false</default>
+		<default>true</default>
 
 		<description>
@@ -556,4 +574,14 @@
 			<para>
 				With this option enabled, root will inform you when someone in your buddy list changes his/her "friendly name".
+			</para>
+		</description>
+	</bitlbee-setting>
+
+	<bitlbee-setting name="display_timestamps" type="boolean" scope="global">
+		<default>true</default>
+
+		<description>
+			<para>
+				When incoming messages are old (i.e. offline messages and channel backlogs), BitlBee will prepend them with a timestamp. If you find them ugly or useless, you can use this setting to hide them.
 			</para>
 		</description>
@@ -609,4 +637,15 @@
 	</bitlbee-setting>
 
+	<bitlbee-setting name="local_display_name" type="boolean" scope="account">
+		<default>false</default>
+
+		<description>
+			<para>
+				Mostly meant to work around a bug in MSN servers (forgetting the display name set by the user), this setting tells BitlBee to store your display name locally and set this name on the MSN servers when connecting.
+			</para>
+		</description>
+
+	</bitlbee-setting>
+
 	<bitlbee-setting name="mail_notifications" type="boolean" scope="account">
 		<default>false</default>
@@ -615,4 +654,24 @@
 			<para>
 				Some protocols (MSN, Yahoo!) can notify via IM about new e-mail. Since most people use their Hotmail/Yahoo! addresses as a spam-box, this is disabled default. If you want these notifications, you can enable this setting.
+			</para>
+		</description>
+
+	</bitlbee-setting>
+
+	<bitlbee-setting name="mode" type="string" scope="account">
+		<possible-values>one, many, chat</possible-values>
+		<default>one</default>
+
+		<description>
+			<para>
+				By default, everything from the Twitter module will come from one nick, twitter_(yourusername). If you prefer to have individual nicks for everyone, you can set this setting to "many" instead.
+			</para>
+			
+			<para>
+				If you prefer to have all your Twitter things in a separate channel, you can set this setting to "chat".
+			</para>
+			
+			<para>
+				In the last two modes, you can send direct messages by /msg'ing your contacts directly. Note, however, that incoming DMs are not fetched yet.
 			</para>
 		</description>
@@ -824,4 +883,37 @@
 			<para>
 				If BitlBee fails to detect this sometimes (most likely in AIM messages over an ICQ connection), you can set this setting to <emphasis>always</emphasis>, but this might sometimes accidentally strip non-HTML things too.
+			</para>
+		</description>
+	</bitlbee-setting>
+
+	<bitlbee-setting name="switchboard_keepalives" type="boolean" scope="account">
+		<default>false</default>
+
+		<description>
+			<para>
+				Turn on this flag if you have difficulties talking to offline/invisible contacts.
+			</para>
+			
+			<para>
+				With this setting enabled, BitlBee will send keepalives to MSN switchboards with offline/invisible contacts every twenty seconds. This should keep the server and client on the other side from shutting it down.
+			</para>
+			
+			<para>
+				This is useful because BitlBee doesn't support MSN offline messages yet and the MSN servers won't let the user reopen switchboards to offline users. Once offline messaging is supported, this flag might be removed.
+			</para>
+		</description>
+	</bitlbee-setting>
+
+	<bitlbee-setting name="timezone" type="string" scope="global">
+		<default>local</default>
+		<possible-values>local, utc, gmt, timezone-spec</possible-values>
+
+		<description>
+			<para>
+				If message timestamps are available for offline messages or chatroom backlogs, BitlBee will display them as part of the message. By default it will use the local timezone. If you're not in the same timezone as the BitlBee server, you can adjust the timestamps using this setting.
+			</para>
+
+			<para>
+				Values local/utc/gmt should be self-explanatory. timezone-spec is a time offset in hours:minutes, for example: -8 for Pacific Standard Time, +2 for Central European Summer Time, +5:30 for Indian Standard Time.
 			</para>
 		</description>
Index: irc.c
===================================================================
--- irc.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ irc.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -53,4 +53,6 @@
 {
 	irc_t *irc = set->data;
+	char *test;
+	gsize test_bytes = 0;
 	GIConv ic, oc;
 
@@ -58,11 +60,25 @@
 		value = g_strdup( "utf-8" );
 
+	if( ( oc = g_iconv_open( value, "utf-8" ) ) == (GIConv) -1 )
+	{
+		return NULL;
+	}
+	
+	/* Do a test iconv to see if the user picked an IRC-compatible
+	   charset (for example utf-16 goes *horribly* wrong). */
+	if( ( test = g_convert_with_iconv( " ", 1, oc, NULL, &test_bytes, NULL ) ) == NULL ||
+	    test_bytes > 1 )
+	{
+		g_free( test );
+		g_iconv_close( oc );
+		irc_usermsg( irc, "Unsupported character set: The IRC protocol "
+		                  "only supports 8-bit character sets." );
+		return NULL;
+	}
+	g_free( test );
+	
 	if( ( ic = g_iconv_open( "utf-8", value ) ) == (GIConv) -1 )
 	{
-		return NULL;
-	}
-	if( ( oc = g_iconv_open( value, "utf-8" ) ) == (GIConv) -1 )
-	{
-		g_iconv_close( ic );
+		g_iconv_close( oc );
 		return NULL;
 	}
@@ -176,4 +192,5 @@
 	s = set_add( &irc->set, "default_target", "root", NULL, irc );
 	s = set_add( &irc->set, "display_namechanges", "false", set_eval_bool, irc );
+	s = set_add( &irc->set, "display_timestamps", "true", set_eval_bool, irc );
 	s = set_add( &irc->set, "handle_unknown", "root", NULL, irc );
 	s = set_add( &irc->set, "lcnicks", "true", set_eval_bool, irc );
@@ -189,4 +206,5 @@
 	s->flags |= SET_NULL_OK;
 	s = set_add( &irc->set, "strip_html", "true", NULL, irc );
+	s = set_add( &irc->set, "timezone", "local", set_eval_timezone, irc );
 	s = set_add( &irc->set, "to_char", ": ", set_eval_to_char, irc );
 	s = set_add( &irc->set, "typing_notice", "false", set_eval_bool, irc );
Index: irc_commands.c
===================================================================
--- irc_commands.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ irc_commands.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -498,5 +498,5 @@
 			irc_reply( irc, 301, "%s :%s", u->nick, u->away );
 		if( u->status_msg )
-			irc_reply( irc, 333, "%s :Status: %s", u->nick, u->status_msg );
+			irc_reply( irc, 320, "%s :%s", u->nick, u->status_msg );
 		
 		irc_reply( irc, 318, "%s :End of /WHOIS list", nick );
Index: lib/misc.c
===================================================================
--- lib/misc.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ lib/misc.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -77,4 +77,39 @@
 	
 	return mktime(&tm);
+}
+
+time_t mktime_utc( struct tm *tp )
+{
+	struct tm utc;
+	time_t res, tres;
+	
+	tp->tm_isdst = -1;
+	res = mktime( tp );
+	/* Problem is, mktime() just gave us the GMT timestamp for the
+	   given local time... While the given time WAS NOT local. So
+	   we should fix this now.
+	   
+	   Now I could choose between messing with environment variables
+	   (kludgy) or using timegm() (not portable)... Or doing the
+	   following, which I actually prefer...
+	   
+	   tzset() may also work but in other places I actually want to
+	   use local time.
+	   
+	   FFFFFFFFFFFFFFFFFFFFFUUUUUUUUUUUUUUUUUUUU!! */
+	gmtime_r( &res, &utc );
+	utc.tm_isdst = -1;
+	if( utc.tm_hour == tp->tm_hour && utc.tm_min == tp->tm_min )
+		/* Sweet! We're in UTC right now... */
+		return res;
+	
+	tres = mktime( &utc );
+	res += res - tres;
+	
+	/* Yes, this is a hack. And it will go wrong around DST changes.
+	   BUT this is more likely to be threadsafe than messing with
+	   environment variables, and possibly more portable... */
+	
+	return res;
 }
 
Index: lib/misc.h
===================================================================
--- lib/misc.h	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ lib/misc.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -43,4 +43,5 @@
 
 G_MODULE_EXPORT time_t get_time( int year, int month, int day, int hour, int min, int sec );
+G_MODULE_EXPORT time_t mktime_utc( struct tm *tp );
 double gettime( void );
 
Index: log.c
===================================================================
--- log.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ log.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -172,4 +172,6 @@
 		fprintf(stdout, "Debug: %s\n", message);
 #endif
+	/* Always log stuff in syslogs too. */
+	log_syslog(level, message);
 	return;
 }
Index: protocols/jabber/jabber_util.c
===================================================================
--- protocols/jabber/jabber_util.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ protocols/jabber/jabber_util.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -671,8 +671,7 @@
 time_t jabber_get_timestamp( struct xt_node *xt )
 {
-	struct tm tp, utc;
 	struct xt_node *c;
-	time_t res, tres;
 	char *s = NULL;
+	struct tm tp;
 	
 	for( c = xt->children; ( c = xt_find_node( c, "x" ) ); c = c->next )
@@ -692,28 +691,6 @@
 	tp.tm_year -= 1900;
 	tp.tm_mon --;
-	tp.tm_isdst = -1; /* GRRRRRRRRRRR */
-	
-	res = mktime( &tp );
-	/* Problem is, mktime() just gave us the GMT timestamp for the
-	   given local time... While the given time WAS NOT local. So
-	   we should fix this now.
-	
-	   Now I could choose between messing with environment variables
-	   (kludgy) or using timegm() (not portable)... Or doing the
-	   following, which I actually prefer... */
-	gmtime_r( &res, &utc );
-	utc.tm_isdst = -1; /* Once more: GRRRRRRRRRRRRRRRRRR!!! */
-	if( utc.tm_hour == tp.tm_hour && utc.tm_min == tp.tm_min )
-		/* Sweet! We're in UTC right now... */
-		return res;
-	
-	tres = mktime( &utc );
-	res += res - tres;
-	
-	/* Yes, this is a hack. And it will go wrong around DST changes.
-	   BUT this is more likely to be threadsafe than messing with
-	   environment variables, and possibly more portable... */
-	
-	return res;
+	
+	return mktime_utc( &tp );
 }
 
Index: protocols/jabber/message.c
===================================================================
--- protocols/jabber/message.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ protocols/jabber/message.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -80,6 +80,6 @@
 		if( type && strcmp( type, "headline" ) == 0 )
 		{
-			c = xt_find_node( node->children, "subject" );
-			g_string_append_printf( fullmsg, "Headline: %s\n", c && c->text_len > 0 ? c->text : "" );
+			if( ( c = xt_find_node( node->children, "subject" ) ) && c->text_len > 0 )
+				g_string_append_printf( fullmsg, "Headline: %s\n", c->text );
 			
 			/* <x xmlns="jabber:x:oob"><url>http://....</url></x> can contain a URL, it seems. */
Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ protocols/msn/msn.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -31,14 +31,12 @@
 GSList *msn_switchboards;
 
-static char *msn_set_display_name( set_t *set, char *value );
+static char *set_eval_display_name( set_t *set, char *value );
 
 static void msn_init( account_t *acc )
 {
-	set_t *s;
-	
-	s = set_add( &acc->set, "display_name", NULL, msn_set_display_name, acc );
-	s->flags |= ACC_SET_NOSAVE | ACC_SET_ONLINE_ONLY;
-
-	s = set_add( &acc->set, "mail_notifications", "false", set_eval_bool, acc );
+	set_add( &acc->set, "display_name", NULL, set_eval_display_name, acc );
+	set_add( &acc->set, "local_display_name", "false", set_eval_bool, acc );
+	set_add( &acc->set, "mail_notifications", "false", set_eval_bool, acc );
+	set_add( &acc->set, "switchboard_keepalives", "false", set_eval_bool, acc );
 }
 
@@ -171,5 +169,5 @@
 static void msn_set_my_name( struct im_connection *ic, char *info )
 {
-	msn_set_display_name( set_find( &ic->acc->set, "display_name" ), info );
+	msn_set_display_name( ic, info );
 }
 
@@ -287,16 +285,12 @@
 }
 
-static char *msn_set_display_name( set_t *set, char *value )
+static char *set_eval_display_name( set_t *set, char *value )
 {
 	account_t *acc = set->data;
 	struct im_connection *ic = acc->ic;
-	struct msn_data *md;
-	char buf[1024], *fn;
-	
-	/* Double-check. */
+	
+	/* Allow any name if we're offline. */
 	if( ic == NULL )
-		return NULL;
-	
-	md = ic->proto_data;
+		return value;
 	
 	if( strlen( value ) > 129 )
@@ -305,15 +299,9 @@
 		return NULL;
 	}
-	
-	fn = msn_http_encode( value );
-	
-	g_snprintf( buf, sizeof( buf ), "REA %d %s %s\r\n", ++md->trId, ic->acc->user, fn );
-	msn_write( ic, buf, strlen( buf ) );
-	g_free( fn );
 	
 	/* Returning NULL would be better, because the server still has to
 	   confirm the name change. However, it looks a bit confusing to the
 	   user. */
-	return value;
+	return msn_set_display_name( ic, value ) ? value : NULL;
 }
 
Index: protocols/msn/msn.h
===================================================================
--- protocols/msn/msn.h	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ protocols/msn/msn.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -31,4 +31,5 @@
 #define TYPING_NOTIFICATION_MESSAGE "\r\r\rBEWARE, ME R TYPINK MESSAGE!!!!\r\r\r"
 #define GROUPCHAT_SWITCHBOARD_MESSAGE "\r\r\rME WANT TALK TO MANY PEOPLE\r\r\r"
+#define SB_KEEPALIVE_MESSAGE "\r\r\rDONT HANG UP ON ME!\r\r\r"
 
 #ifdef DEBUG_MSN
@@ -53,4 +54,8 @@
                            "TypingUser: %s\r\n" \
                            "\r\n\r\n"
+
+#define SB_KEEPALIVE_HEADERS "MIME-Version: 1.0\r\n" \
+                             "Content-Type: text/x-ping\r\n" \
+                             "\r\n\r\n"
 
 #define PROFILE_URL "http://members.msn.com/"
@@ -84,4 +89,5 @@
 	gint inp;
 	struct msn_handler_data *handler;
+	gint keepalive;
 	
 	int trId;
@@ -162,4 +168,5 @@
 char *msn_http_encode( const char *input );
 void msn_msgq_purge( struct im_connection *ic, GSList **list );
+gboolean msn_set_display_name( struct im_connection *ic, const char *rawname );
 
 /* tables.c */
@@ -180,4 +187,6 @@
 gboolean msn_sb_connected( gpointer data, gint source, b_input_condition cond );
 int msn_sb_write_msg( struct im_connection *ic, struct msn_message *m );
+void msn_sb_start_keepalives( struct msn_switchboard *sb, gboolean initial );
+void msn_sb_stop_keepalives( struct msn_switchboard *sb );
 
 /* invitation.c */
Index: protocols/msn/msn_util.c
===================================================================
--- protocols/msn/msn_util.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ protocols/msn/msn_util.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -38,8 +38,8 @@
 		imcb_error( ic, "Short write() to main server" );
 		imc_logout( ic, TRUE );
-		return( 0 );
-	}
-	
-	return( 1 );
+		return 0;
+	}
+	
+	return 1;
 }
 
@@ -377,2 +377,14 @@
 	g_string_free( ret, TRUE );
 }
+
+gboolean msn_set_display_name( struct im_connection *ic, const char *rawname )
+{
+	char *fn = msn_http_encode( rawname );
+	struct msn_data *md = ic->proto_data;
+	char buf[1024];
+	
+	g_snprintf( buf, sizeof( buf ), "REA %d %s %s\r\n", ++md->trId, ic->acc->user, fn );
+	g_free( fn );
+	
+	return msn_write( ic, buf, strlen( buf ) ) != 0;
+}
Index: protocols/msn/ns.c
===================================================================
--- protocols/msn/ns.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ protocols/msn/ns.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -35,4 +35,5 @@
 
 static void msn_auth_got_passport_token( struct msn_auth_data *mad );
+static gboolean msn_ns_got_display_name( struct im_connection *ic, char *name );
 
 gboolean msn_ns_connected( gpointer data, gint source, b_input_condition cond )
@@ -231,23 +232,8 @@
 		else if( num_parts >= 7 && strcmp( cmd[2], "OK" ) == 0 )
 		{
-			set_t *s;
-			
 			if( num_parts == 7 )
-			{
-				http_decode( cmd[4] );
-				
-				strncpy( ic->displayname, cmd[4], sizeof( ic->displayname ) );
-				ic->displayname[sizeof(ic->displayname)-1] = 0;
-				
-				if( ( s = set_find( &ic->acc->set, "display_name" ) ) )
-				{
-					g_free( s->value );
-					s->value = g_strdup( cmd[4] );
-				}
-			}
+				msn_ns_got_display_name( ic, cmd[4] );
 			else
-			{
 				imcb_log( ic, "Warning: Friendly name in server response was corrupted" );
-			}
 			
 			imcb_log( ic, "Authenticated, getting buddy list" );
@@ -436,6 +422,10 @@
 	else if( strcmp( cmd[0], "FLN" ) == 0 )
 	{
-		if( cmd[1] )
-			imcb_buddy_status( ic, cmd[1], 0, NULL, NULL );
+		if( cmd[1] == NULL )
+			return 1;
+		
+		imcb_buddy_status( ic, cmd[1], 0, NULL, NULL );
+		
+		msn_sb_start_keepalives( msn_sb_by_handle( ic, cmd[1] ), TRUE );
 	}
 	else if( strcmp( cmd[0], "NLN" ) == 0 )
@@ -463,4 +453,6 @@
 		                   ( st != msn_away_state_list ? OPT_AWAY : 0 ),
 		                   st->name, NULL );
+		
+		msn_sb_stop_keepalives( msn_sb_by_handle( ic, cmd[2] ) );
 	}
 	else if( strcmp( cmd[0], "RNG" ) == 0 )
@@ -567,4 +559,7 @@
 		return( 0 );
 	}
+#if 0
+	/* Discard this one completely for now since I don't care about the ack
+	   and since MSN servers can apparently screw up the formatting. */
 	else if( strcmp( cmd[0], "REA" ) == 0 )
 	{
@@ -597,4 +592,5 @@
 		}
 	}
+#endif
 	else if( strcmp( cmd[0], "IPG" ) == 0 )
 	{
@@ -746,2 +742,47 @@
 	}
 }
+
+static gboolean msn_ns_got_display_name( struct im_connection *ic, char *name )
+{
+	set_t *s;
+	
+	if( ( s = set_find( &ic->acc->set, "display_name" ) ) == NULL )
+		return FALSE; /* Shouldn't happen.. */
+	
+	http_decode( name );
+	
+	if( s->value && strcmp( s->value, name ) == 0 )
+	{
+		return TRUE;
+		/* The names match, nothing to worry about. */
+	}
+	else if( s->value != NULL &&
+	         ( strcmp( name, ic->acc->user ) == 0 ||
+	           set_getbool( &ic->acc->set, "local_display_name" ) ) )
+	{
+		/* The server thinks our display name is our e-mail address
+		   which is probably wrong, or the user *wants* us to do this:
+		   Always use the locally set display_name. */
+		return msn_set_display_name( ic, s->value );
+	}
+	else
+	{
+		if( s->value && *s->value )
+			imcb_log( ic, "BitlBee thinks your display name is `%s' but "
+			              "the MSN server says it's `%s'. Using the MSN "
+			              "server's name. Set local_display_name to true "
+			              "to use the local name.", s->value, name );
+		
+		if( g_utf8_validate( name, -1, NULL ) )
+		{
+			g_free( s->value );
+			s->value = g_strdup( name );
+		}
+		else
+		{
+			imcb_log( ic, "Warning: Friendly name in server response was corrupted" );
+		}
+		
+		return TRUE;
+	}
+}
Index: protocols/msn/sb.c
===================================================================
--- protocols/msn/sb.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ protocols/msn/sb.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -180,4 +180,9 @@
 			i = strlen( buf );
 		}
+		else if( strcmp( text, SB_KEEPALIVE_MESSAGE ) == 0 )
+		{
+			buf = g_strdup( SB_KEEPALIVE_HEADERS );
+			i = strlen( buf );
+		}
 		else
 		{
@@ -256,4 +261,5 @@
 	
 	msn_msgq_purge( ic, &sb->msgq );
+	msn_sb_stop_keepalives( sb );
 	
 	if( sb->key ) g_free( sb->key );
@@ -477,4 +483,6 @@
 		
 		sb->ready = 1;
+		
+		msn_sb_start_keepalives( sb, FALSE );
 	}
 	else if( strcmp( cmd[0], "CAL" ) == 0 )
@@ -526,4 +534,6 @@
 			}
 			
+			msn_sb_start_keepalives( sb, FALSE );
+			
 			return( st );
 		}
@@ -587,4 +597,6 @@
 		if( sb->who )
 		{
+			msn_sb_stop_keepalives( sb );
+			
 			/* This is a single-person chat, and the other person is leaving. */
 			g_free( sb->who );
@@ -749,2 +761,32 @@
 	return( 1 );
 }
+
+static gboolean msn_sb_keepalive( gpointer data, gint source, b_input_condition cond )
+{
+	struct msn_switchboard *sb = data;
+	return sb->ready && msn_sb_sendmessage( sb, SB_KEEPALIVE_MESSAGE );
+}
+
+void msn_sb_start_keepalives( struct msn_switchboard *sb, gboolean initial )
+{
+	struct buddy *b;
+	
+	if( sb && sb->who && sb->keepalive == 0 &&
+	    ( b = imcb_find_buddy( sb->ic, sb->who ) ) && !b->present &&
+	    set_getbool( &sb->ic->acc->set, "switchboard_keepalives" ) )
+	{
+		if( initial )
+			msn_sb_keepalive( sb, 0, 0 );
+		
+		sb->keepalive = b_timeout_add( 20000, msn_sb_keepalive, sb );
+	}
+}
+
+void msn_sb_stop_keepalives( struct msn_switchboard *sb )
+{
+	if( sb && sb->keepalive > 0 )
+	{
+		b_event_remove( sb->keepalive );
+		sb->keepalive = 0;
+	}
+}
Index: protocols/nogaim.c
===================================================================
--- protocols/nogaim.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ protocols/nogaim.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -39,4 +39,5 @@
 
 static int remove_chat_buddy_silent( struct groupchat *b, const char *handle );
+static char *format_timestamp( irc_t *irc, time_t msg_ts );
 
 GSList *connections;
@@ -135,4 +136,5 @@
 	extern void byahoo_initmodule();
 	extern void jabber_initmodule();
+	extern void twitter_initmodule();
 	extern void purple_initmodule();
 
@@ -151,4 +153,8 @@
 #ifdef WITH_JABBER
 	jabber_initmodule();
+#endif
+
+#ifdef WITH_TWITTER
+	twitter_initmodule();
 #endif
 	
@@ -726,5 +732,5 @@
 {
 	irc_t *irc = ic->irc;
-	char *wrapped;
+	char *wrapped, *ts = NULL;
 	user_t *u;
 	
@@ -768,8 +774,17 @@
 	    ( ( ic->flags & OPT_DOES_HTML ) && set_getbool( &ic->irc->set, "strip_html" ) ) )
 		strip_html( msg );
-
+	
+	if( set_getbool( &ic->irc->set, "display_timestamps" ) &&
+	    ( ts = format_timestamp( irc, sent_at ) ) )
+	{
+		char *new = g_strconcat( ts, msg, NULL );
+		g_free( ts );
+		ts = msg = new;
+	}
+	
 	wrapped = word_wrap( msg, 425 );
 	irc_msgfrom( irc, u->nick, wrapped );
 	g_free( wrapped );
+	g_free( ts );
 }
 
@@ -813,4 +828,33 @@
 	
 	return c;
+}
+
+void imcb_chat_name_hint( struct groupchat *c, const char *name )
+{
+	if( !c->joined )
+	{
+		struct im_connection *ic = c->ic;
+		char stripped[MAX_NICK_LENGTH+1], *full_name;
+		
+		strncpy( stripped, name, MAX_NICK_LENGTH );
+		stripped[MAX_NICK_LENGTH] = '\0';
+		nick_strip( stripped );
+		if( set_getbool( &ic->irc->set, "lcnicks" ) )
+			nick_lc( stripped );
+		
+		full_name = g_strdup_printf( "&%s", stripped );
+		
+		if( stripped[0] &&
+		    nick_cmp( stripped, ic->irc->channel + 1 ) != 0 &&
+		    irc_chat_by_channel( ic->irc, full_name ) == NULL )
+		{
+			g_free( c->channel );
+			c->channel = full_name;
+		}
+		else
+		{
+			g_free( full_name );
+		}
+	}
 }
 
@@ -875,5 +919,9 @@
 	if( c && u )
 	{
-		irc_privmsg( ic->irc, u, "PRIVMSG", c->channel, "", wrapped );
+		char *ts = NULL;
+		if( set_getbool( &ic->irc->set, "display_timestamps" ) )
+			ts = format_timestamp( ic->irc, sent_at );
+		irc_privmsg( ic->irc, u, "PRIVMSG", c->channel, ts ? : "", wrapped );
+		g_free( ts );
 	}
 	else
@@ -1069,6 +1117,92 @@
 }
 
-
-
+char *set_eval_timezone( set_t *set, char *value )
+{
+	char *s;
+	
+	if( strcmp( value, "local" ) == 0 ||
+	    strcmp( value, "gmt" ) == 0 || strcmp( value, "utc" ) == 0 )
+		return value;
+	
+	/* Otherwise: +/- at the beginning optional, then one or more numbers,
+	   possibly followed by a colon and more numbers. Don't bother bound-
+	   checking them since users are free to shoot themselves in the foot. */
+	s = value;
+	if( *s == '+' || *s == '-' )
+		s ++;
+	
+	/* \d+ */
+	if( !isdigit( *s ) )
+		return SET_INVALID;
+	while( *s && isdigit( *s ) ) s ++;
+	
+	/* EOS? */
+	if( *s == '\0' )
+		return value;
+	
+	/* Otherwise, colon */
+	if( *s != ':' )
+		return SET_INVALID;
+	s ++;
+	
+	/* \d+ */
+	if( !isdigit( *s ) )
+		return SET_INVALID;
+	while( *s && isdigit( *s ) ) s ++;
+	
+	/* EOS */
+	return *s == '\0' ? value : SET_INVALID;
+}
+
+static char *format_timestamp( irc_t *irc, time_t msg_ts )
+{
+	time_t now_ts = time( NULL );
+	struct tm now, msg;
+	char *set;
+	
+	/* If the timestamp is <= 0 or less than a minute ago, discard it as
+	   it doesn't seem to add to much useful info and/or might be noise. */
+	if( msg_ts <= 0 || msg_ts > now_ts - 60 )
+		return NULL;
+	
+	set = set_getstr( &irc->set, "timezone" );
+	if( strcmp( set, "local" ) == 0 )
+	{
+		localtime_r( &now_ts, &now );
+		localtime_r( &msg_ts, &msg );
+	}
+	else
+	{
+		int hr, min = 0, sign = 60;
+		
+		if( set[0] == '-' )
+		{
+			sign *= -1;
+			set ++;
+		}
+		else if( set[0] == '+' )
+		{
+			set ++;
+		}
+		
+		if( sscanf( set, "%d:%d", &hr, &min ) >= 1 )
+		{
+			msg_ts += sign * ( hr * 60 + min );
+			now_ts += sign * ( hr * 60 + min );
+		}
+		
+		gmtime_r( &now_ts, &now );
+		gmtime_r( &msg_ts, &msg );
+	}
+	
+	if( msg.tm_year == now.tm_year && msg.tm_yday == now.tm_yday )
+		return g_strdup_printf( "\x02[\x02\x02\x02%02d:%02d:%02d\x02]\x02 ",
+		                        msg.tm_hour, msg.tm_min, msg.tm_sec );
+	else
+		return g_strdup_printf( "\x02[\x02\x02\x02%04d-%02d-%02d "
+		                        "%02d:%02d:%02d\x02]\x02 ",
+		                        msg.tm_year + 1900, msg.tm_mon, msg.tm_mday,
+		                        msg.tm_hour, msg.tm_min, msg.tm_sec );
+}
 
 /* The plan is to not allow straight calls to prpl functions anymore, but do
@@ -1113,4 +1247,8 @@
 {
 	char *away, *msg = NULL;
+	
+	if( ic->acc->prpl->away_states == NULL ||
+	    ic->acc->prpl->set_away == NULL )
+		return 0;
 	
 	away = set_getstr( &ic->acc->set, "away" ) ?
Index: protocols/nogaim.h
===================================================================
--- protocols/nogaim.h	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ protocols/nogaim.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -308,4 +308,5 @@
  *   user, too. */
 G_MODULE_EXPORT struct groupchat *imcb_chat_new( struct im_connection *ic, const char *handle );
+G_MODULE_EXPORT void imcb_chat_name_hint( struct groupchat *c, const char *name );
 G_MODULE_EXPORT void imcb_chat_add_buddy( struct groupchat *b, const char *handle );
 /* To remove a handle from a group chat. Reason can be NULL. */
@@ -330,4 +331,5 @@
 
 /* Misc. stuff */
+char *set_eval_timezone( set_t *set, char *value );
 char *set_eval_away_devoice( set_t *set, char *value );
 gboolean auto_reconnect( gpointer data, gint fd, b_input_condition cond );
Index: protocols/twitter/Makefile
===================================================================
--- protocols/twitter/Makefile	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
+++ protocols/twitter/Makefile	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -0,0 +1,43 @@
+###########################
+## Makefile for BitlBee  ##
+##                       ##
+## Copyright 2002 Lintux ##
+###########################
+
+### DEFINITIONS
+
+-include ../../Makefile.settings
+
+# [SH] Program variables
+objects = twitter.o twitter_http.o twitter_lib.o
+
+CFLAGS += -Wall
+LFLAGS += -r
+
+# [SH] Phony targets
+all: twitter_mod.o
+check: all
+lcov: check
+gcov: 
+	gcov *.c
+	
+.PHONY: all clean distclean
+
+clean:
+	rm -f *.o core
+
+distclean: clean
+
+### MAIN PROGRAM
+
+$(objects): ../../Makefile.settings Makefile
+
+$(objects): %.o: %.c
+	@echo '*' Compiling $<
+	@$(CC) -c $(CFLAGS) $< -o $@
+
+twitter_mod.o: $(objects)
+	@echo '*' Linking twitter_mod.o
+	@$(LD) $(LFLAGS) $(objects) -o twitter_mod.o
+	
+
Index: protocols/twitter/twitter.c
===================================================================
--- protocols/twitter/twitter.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
+++ protocols/twitter/twitter.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -0,0 +1,248 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+#include "nogaim.h"
+#include "twitter.h"
+#include "twitter_http.h"
+#include "twitter_lib.h"
+
+
+/**
+ * Main loop function
+ */
+gboolean twitter_main_loop(gpointer data, gint fd, b_input_condition cond)
+{
+	struct im_connection *ic = data;
+	
+	// Check if we are still logged in...
+	if (!g_slist_find( twitter_connections, ic ))
+		return 0;
+
+	// If the user uses multiple private message windows we need to get the 
+	// users buddies.
+	if (g_strcasecmp(set_getstr(&ic->acc->set, "mode"), "many") == 0)
+		twitter_get_statuses_friends(ic, -1);
+
+	// Do stuff..
+	twitter_get_home_timeline(ic, -1);
+
+	// If we are still logged in run this function again after timeout.
+	return (ic->flags & OPT_LOGGED_IN) == OPT_LOGGED_IN;
+}
+
+static char *set_eval_mode( set_t *set, char *value )
+{
+	if( g_strcasecmp( value, "one" ) == 0 ||
+	    g_strcasecmp( value, "many" ) == 0 ||
+	    g_strcasecmp( value, "chat" ) == 0 )
+		return value;
+	else
+		return NULL;
+}
+
+static void twitter_init( account_t *acc )
+{
+	set_t *s;
+	
+	s = set_add( &acc->set, "mode", "one", set_eval_mode, acc );
+	s->flags |= ACC_SET_OFFLINE_ONLY;
+}
+
+/**
+ * Login method. Since the twitter API works with seperate HTTP request we 
+ * only save the user and pass to the twitter_data object.
+ */
+static void twitter_login( account_t *acc )
+{
+	struct im_connection *ic = imcb_new( acc );
+	struct twitter_data *td = g_new0( struct twitter_data, 1 );
+	char name[strlen(acc->user)+9];
+
+	twitter_connections = g_slist_append( twitter_connections, ic );
+
+	td->user = acc->user;
+	td->pass = acc->pass;
+	td->home_timeline_id = 0;
+
+	ic->proto_data = td;
+
+	imcb_log( ic, "Connecting to Twitter" );
+
+	// Run this once. After this queue the main loop function.
+	twitter_main_loop(ic, -1, 0);
+
+	// Queue the main_loop
+	// Save the return value, so we can remove the timeout on logout.
+	td->main_loop_id = b_timeout_add(60000, twitter_main_loop, ic);
+	
+	sprintf( name, "twitter_%s", acc->user );
+	imcb_add_buddy( ic, name, NULL );
+	imcb_buddy_status( ic, name, OPT_LOGGED_IN, NULL, NULL );
+}
+
+/**
+ * Logout method. Just free the twitter_data.
+ */
+static void twitter_logout( struct im_connection *ic )
+{
+	struct twitter_data *td = ic->proto_data;
+	
+	// Set the status to logged out.
+	ic->flags = 0;
+
+	// Remove the main_loop function from the function queue.
+	b_event_remove(td->main_loop_id);
+
+	if(td->home_timeline_gc)
+		imcb_chat_free(td->home_timeline_gc);
+
+	if( td )
+	{
+		g_free( td );
+	}
+
+	twitter_connections = g_slist_remove( twitter_connections, ic );
+}
+
+/**
+ *
+ */
+static int twitter_buddy_msg( struct im_connection *ic, char *who, char *message, int away )
+{
+	if (g_strncasecmp(who, "twitter_", 8) == 0 &&
+	    g_strcasecmp(who + 8, ic->acc->user) == 0)
+		twitter_post_status(ic, message);
+	else
+		twitter_direct_messages_new(ic, who, message);
+	
+	return( 0 );
+}
+
+/**
+ *
+ */
+static void twitter_set_my_name( struct im_connection *ic, char *info )
+{
+}
+
+static void twitter_get_info(struct im_connection *ic, char *who) 
+{
+}
+
+static void twitter_add_buddy( struct im_connection *ic, char *who, char *group )
+{
+}
+
+static void twitter_remove_buddy( struct im_connection *ic, char *who, char *group )
+{
+}
+
+static void twitter_chat_msg( struct groupchat *c, char *message, int flags )
+{
+	if( c && message )
+		twitter_post_status(c->ic, message);
+}
+
+static void twitter_chat_invite( struct groupchat *c, char *who, char *message )
+{
+}
+
+static void twitter_chat_leave( struct groupchat *c )
+{
+	struct twitter_data *td = c->ic->proto_data;
+	
+	if( c != td->home_timeline_gc )
+		return; /* WTF? */
+	
+	/* If the user leaves the channel: Fine. Rejoin him/her once new
+	   tweets come in. */
+	imcb_chat_free(td->home_timeline_gc);
+	td->home_timeline_gc = NULL;
+}
+
+static struct groupchat *twitter_chat_with( struct im_connection *ic, char *who )
+{
+	return NULL;
+}
+
+static void twitter_keepalive( struct im_connection *ic )
+{
+}
+
+static void twitter_add_permit( struct im_connection *ic, char *who )
+{
+}
+
+static void twitter_rem_permit( struct im_connection *ic, char *who )
+{
+}
+
+static void twitter_add_deny( struct im_connection *ic, char *who )
+{
+}
+
+static void twitter_rem_deny( struct im_connection *ic, char *who )
+{
+}
+
+static int twitter_send_typing( struct im_connection *ic, char *who, int typing )
+{
+	return( 1 );
+}
+
+//static char *twitter_set_display_name( set_t *set, char *value )
+//{
+//	return value;
+//}
+
+void twitter_initmodule()
+{
+	struct prpl *ret = g_new0(struct prpl, 1);
+	
+	ret->name = "twitter";
+	ret->login = twitter_login;
+	ret->init = twitter_init;
+	ret->logout = twitter_logout;
+	ret->buddy_msg = twitter_buddy_msg;
+	ret->get_info = twitter_get_info;
+	ret->set_my_name = twitter_set_my_name;
+	ret->add_buddy = twitter_add_buddy;
+	ret->remove_buddy = twitter_remove_buddy;
+	ret->chat_msg = twitter_chat_msg;
+	ret->chat_invite = twitter_chat_invite;
+	ret->chat_leave = twitter_chat_leave;
+	ret->chat_with = twitter_chat_with;
+	ret->keepalive = twitter_keepalive;
+	ret->add_permit = twitter_add_permit;
+	ret->rem_permit = twitter_rem_permit;
+	ret->add_deny = twitter_add_deny;
+	ret->rem_deny = twitter_rem_deny;
+	ret->send_typing = twitter_send_typing;
+	ret->handle_cmp = g_strcasecmp;
+
+	register_protocol(ret);
+
+	// Initialise the twitter_connections GSList.
+	twitter_connections = NULL;
+}
+
Index: protocols/twitter/twitter.h
===================================================================
--- protocols/twitter/twitter.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
+++ protocols/twitter/twitter.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -0,0 +1,52 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+#include "nogaim.h"
+
+#ifndef _TWITTER_H
+#define _TWITTER_H
+
+#ifdef DEBUG_TWITTER
+#define debug( text... ) imcb_log( ic, text );
+#else
+#define debug( text... )
+#endif
+
+struct twitter_data
+{
+	char* user;
+	char* pass;
+	guint64 home_timeline_id;
+	gint main_loop_id;
+	struct groupchat *home_timeline_gc;
+	gint http_fails;
+};
+
+/**
+ * This has the same function as the msn_connections GSList. We use this to 
+ * make sure the connection is still alive in callbacks before we do anything
+ * else.
+ */
+GSList *twitter_connections;
+
+#endif //_TWITTER_H
Index: protocols/twitter/twitter_http.c
===================================================================
--- protocols/twitter/twitter_http.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
+++ protocols/twitter/twitter_http.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -0,0 +1,161 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+/***************************************************************************\
+*                                                                           *
+*  Some funtions within this file have been copied from other files within  *
+*  BitlBee.                                                                 *
+*                                                                           *
+****************************************************************************/ 
+
+#include "twitter_http.h"
+#include "twitter.h"
+#include "bitlbee.h"
+#include "url.h"
+#include "misc.h"
+#include "base64.h"
+#include <ctype.h>
+#include <errno.h>
+
+
+char *twitter_url_append(char *url, char *key, char* value);
+
+/**
+ * Do a request.
+ * This is actually pretty generic function... Perhaps it should move to the lib/http_client.c
+ */
+void *twitter_http(char *url_string, http_input_function func, gpointer data, int is_post, char* user, char* pass, char** arguments, int arguments_len)
+{
+	url_t *url = g_new0( url_t, 1 );
+	char *tmp;
+	char *request;
+	void *ret;
+	char *userpass = NULL;
+	char *userpass_base64;
+	char *url_arguments;
+
+	// Fill the url structure.
+	if( !url_set( url, url_string ) )
+	{
+		g_free( url );
+		return NULL;
+	}
+
+	if( url->proto != PROTO_HTTP && url->proto != PROTO_HTTPS )
+	{
+		g_free( url );
+		return NULL;
+	}
+
+	// Concatenate user and pass
+	if (user && pass) {
+		userpass = g_strdup_printf("%s:%s", user, pass);
+		userpass_base64 = base64_encode((unsigned char*)userpass, strlen(userpass));
+	} else {
+		userpass_base64 = NULL;
+	}
+
+	url_arguments = g_malloc(1);
+	url_arguments[0] = '\0';
+
+	// Construct the url arguments.
+	if (arguments_len != 0)
+	{
+		int i;
+		for (i=0; i<arguments_len; i+=2) 
+		{
+			tmp = twitter_url_append(url_arguments, arguments[i], arguments[i+1]);
+			g_free(url_arguments);
+			url_arguments = tmp;
+		}
+	}
+
+	// Do GET stuff...
+	if (!is_post)
+	{
+		// Find the char-pointer of the end of the string.
+		tmp = url->file + strlen(url->file);
+		tmp[0] = '?';
+		// append the url_arguments to the end of the url->file.
+		// TODO GM: Check the length?
+		g_stpcpy (tmp+1, url_arguments);
+	}
+
+
+	// Make the request.
+	request = g_strdup_printf(  "%s %s HTTP/1.0\r\n"
+	                            "Host: %s\r\n"
+	                            "User-Agent: BitlBee " BITLBEE_VERSION " " ARCH "/" CPU "\r\n",
+	                            is_post ? "POST" : "GET", url->file, url->host );
+
+	// If a pass and user are given we append them to the request.
+	if (userpass_base64)
+	{
+		tmp = g_strdup_printf("%sAuthorization: Basic %s\r\n", request, userpass_base64);
+		g_free(request);
+		request = tmp;
+	}
+
+	// Do POST stuff..
+	if (is_post)
+	{
+		// Append the Content-Type and url-encoded arguments.
+		tmp = g_strdup_printf("%sContent-Type: application/x-www-form-urlencoded\r\nContent-Length: %zd\r\n\r\n%s", 
+								request, strlen(url_arguments), url_arguments);
+		g_free(request);
+		request = tmp;
+	} else {
+		// Append an extra \r\n to end the request...
+		tmp = g_strdup_printf("%s\r\n", request);
+		g_free(request);
+		request = tmp;
+	}
+
+	ret = http_dorequest( url->host, url->port,	url->proto == PROTO_HTTPS, request, func, data );
+
+	g_free( url );
+	g_free( userpass );
+	g_free( userpass_base64 );
+	g_free( url_arguments );
+	g_free( request );
+	return ret;
+}
+
+char *twitter_url_append(char *url, char *key, char* value)
+{
+	char *key_encoded = g_strndup(key, 3 * strlen(key));
+	http_encode(key_encoded);
+	char *value_encoded = g_strndup(value, 3 * strlen(value));
+	http_encode(value_encoded);
+
+	char *retval;
+	if (strlen(url) != 0)
+		retval = g_strdup_printf("%s&%s=%s", url, key_encoded, value_encoded);
+	else
+		retval = g_strdup_printf("%s=%s", key_encoded, value_encoded);
+
+	g_free(key_encoded);
+	g_free(value_encoded);
+
+	return retval;
+}
Index: protocols/twitter/twitter_http.h
===================================================================
--- protocols/twitter/twitter_http.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
+++ protocols/twitter/twitter_http.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -0,0 +1,34 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+#ifndef _TWITTER_HTTP_H
+#define _TWITTER_HTTP_H
+
+#include "nogaim.h"
+#include "http_client.h"
+
+void *twitter_http(char *url_string, http_input_function func, gpointer data, int is_post, 
+					char* user, char* pass, char** arguments, int arguments_len);
+
+#endif //_TWITTER_HTTP_H
+
Index: protocols/twitter/twitter_lib.c
===================================================================
--- protocols/twitter/twitter_lib.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
+++ protocols/twitter/twitter_lib.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -0,0 +1,677 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+/* For strptime(): */
+#define _XOPEN_SOURCE
+
+#include "twitter_http.h"
+#include "twitter.h"
+#include "bitlbee.h"
+#include "url.h"
+#include "misc.h"
+#include "base64.h"
+#include "xmltree.h"
+#include "twitter_lib.h"
+#include <ctype.h>
+#include <errno.h>
+
+#define TXL_STATUS 1
+#define TXL_USER 2
+#define TXL_ID 3
+
+struct twitter_xml_list {
+	int type;
+	int next_cursor;
+	GSList *list;
+	gpointer data;
+};
+
+struct twitter_xml_user {
+	char *name;
+	char *screen_name;
+};
+
+struct twitter_xml_status {
+	time_t created_at;
+	char *text;
+	struct twitter_xml_user *user;
+	guint64 id;
+};
+
+/**
+ * Frees a twitter_xml_user struct.
+ */
+static void txu_free(struct twitter_xml_user *txu)
+{
+	g_free(txu->name);
+	g_free(txu->screen_name);
+	g_free(txu);
+}
+
+
+/**
+ * Frees a twitter_xml_status struct.
+ */
+static void txs_free(struct twitter_xml_status *txs)
+{
+	g_free(txs->text);
+	txu_free(txs->user);
+	g_free(txs);
+}
+
+/**
+ * Free a twitter_xml_list struct.
+ * type is the type of list the struct holds.
+ */
+static void txl_free(struct twitter_xml_list *txl)
+{
+	GSList *l;
+	for ( l = txl->list; l ; l = g_slist_next(l) )
+		if (txl->type == TXL_STATUS)
+			txs_free((struct twitter_xml_status *)l->data);
+		else if (txl->type == TXL_ID)
+			g_free(l->data);
+	g_slist_free(txl->list);
+}
+
+/**
+ * Add a buddy if it is not allready added, set the status to logged in.
+ */
+static void twitter_add_buddy(struct im_connection *ic, char *name, const char *fullname)
+{
+	struct twitter_data *td = ic->proto_data;
+
+	// Check if the buddy is allready in the buddy list.
+	if (!imcb_find_buddy( ic, name ))
+	{
+		char *mode = set_getstr(&ic->acc->set, "mode");
+		
+		// The buddy is not in the list, add the buddy and set the status to logged in.
+		imcb_add_buddy( ic, name, NULL );
+		imcb_rename_buddy( ic, name, fullname );
+		if (g_strcasecmp(mode, "chat") == 0)
+			imcb_chat_add_buddy( td->home_timeline_gc, name );
+		else if (g_strcasecmp(mode, "many") == 0)
+			imcb_buddy_status( ic, name, OPT_LOGGED_IN, NULL, NULL );
+	}
+}
+
+static void twitter_http_get_friends_ids(struct http_request *req);
+
+/**
+ * Get the friends ids.
+ */
+void twitter_get_friends_ids(struct im_connection *ic, int next_cursor)
+{
+	struct twitter_data *td = ic->proto_data;
+
+	// Primitive, but hey! It works...	
+	char* args[2];
+	args[0] = "cursor";
+	args[1] = g_strdup_printf ("%d", next_cursor);
+	twitter_http(TWITTER_FRIENDS_IDS_URL, twitter_http_get_friends_ids, ic, 0, td->user, td->pass, args, 2);
+
+	g_free(args[1]);
+}
+
+/**
+ * Function to help fill a list.
+ */
+static xt_status twitter_xt_next_cursor( struct xt_node *node, struct twitter_xml_list *txl )
+{
+	// Do something with the cursor.
+	txl->next_cursor = node->text != NULL ? atoi(node->text) : -1;
+
+	return XT_HANDLED;
+}
+
+/**
+ * Fill a list of ids.
+ */
+static xt_status twitter_xt_get_friends_id_list( struct xt_node *node, struct twitter_xml_list *txl )
+{
+	struct xt_node *child;
+	
+	// Set the list type.
+	txl->type = TXL_ID;
+
+	// The root <statuses> node should hold the list of statuses <status>
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "id", child->name ) == 0)
+		{
+			// Add the item to the list.
+			txl->list = g_slist_append (txl->list, g_memdup( child->text, child->text_len + 1 ));
+		}
+		else if ( g_strcasecmp( "next_cursor", child->name ) == 0)
+		{
+			twitter_xt_next_cursor(child, txl);
+		}
+	}
+
+	return XT_HANDLED;
+}
+
+/**
+ * Callback for getting the friends ids.
+ */
+static void twitter_http_get_friends_ids(struct http_request *req)
+{
+	struct im_connection *ic;
+	struct xt_parser *parser;
+	struct twitter_xml_list *txl;
+	struct twitter_data *td;
+
+	ic = req->data;
+
+	// Check if the connection is still active.
+	if( !g_slist_find( twitter_connections, ic ) )
+		return;
+	
+	td = ic->proto_data;
+
+	// Check if the HTTP request went well.
+	if (req->status_code != 200) {
+		// It didn't go well, output the error and return.
+		if (++td->http_fails >= 5)
+			imcb_error(ic, "Could not retrieve friends. HTTP STATUS: %d", req->status_code);
+		
+		return;
+	} else {
+		td->http_fails = 0;
+	}
+
+	txl = g_new0(struct twitter_xml_list, 1);
+
+	// Parse the data.
+	parser = xt_new( NULL, txl );
+	xt_feed( parser, req->reply_body, req->body_size );
+	twitter_xt_get_friends_id_list(parser->root, txl);
+	xt_free( parser );
+
+	if (txl->next_cursor)
+		twitter_get_friends_ids(ic, txl->next_cursor);
+
+	txl_free(txl);
+	g_free(txl);
+}
+
+/**
+ * Function to fill a twitter_xml_user struct.
+ * It sets:
+ *  - the name and
+ *  - the screen_name.
+ */
+static xt_status twitter_xt_get_user( struct xt_node *node, struct twitter_xml_user *txu )
+{
+	struct xt_node *child;
+
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "name", child->name ) == 0)
+		{
+			txu->name = g_memdup( child->text, child->text_len + 1 );
+		}
+		else if (g_strcasecmp( "screen_name", child->name ) == 0)
+		{
+			txu->screen_name = g_memdup( child->text, child->text_len + 1 );
+		}
+	}
+	return XT_HANDLED;
+}
+
+/**
+ * Function to fill a twitter_xml_list struct.
+ * It sets:
+ *  - all <user>s from the <users> element.
+ */
+static xt_status twitter_xt_get_users( struct xt_node *node, struct twitter_xml_list *txl )
+{
+	struct twitter_xml_user *txu;
+	struct xt_node *child;
+
+	// Set the type of the list.
+	txl->type = TXL_USER;
+
+	// The root <users> node should hold the list of users <user>
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "user", child->name ) == 0)
+		{
+			txu = g_new0(struct twitter_xml_user, 1);
+			twitter_xt_get_user(child, txu);
+			// Put the item in the front of the list.
+			txl->list = g_slist_prepend (txl->list, txu);
+		}
+	}
+
+	return XT_HANDLED;
+}
+
+/**
+ * Function to fill a twitter_xml_list struct.
+ * It calls twitter_xt_get_users to get the <user>s from a <users> element.
+ * It sets:
+ *  - the next_cursor.
+ */
+static xt_status twitter_xt_get_user_list( struct xt_node *node, struct twitter_xml_list *txl )
+{
+	struct xt_node *child;
+
+	// Set the type of the list.
+	txl->type = TXL_USER;
+
+	// The root <user_list> node should hold a users <users> element
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "users", child->name ) == 0)
+		{
+			twitter_xt_get_users(child, txl);
+		}
+		else if ( g_strcasecmp( "next_cursor", child->name ) == 0)
+		{
+			twitter_xt_next_cursor(child, txl);
+		}
+	}
+
+	return XT_HANDLED;
+}
+
+
+/**
+ * Function to fill a twitter_xml_status struct.
+ * It sets:
+ *  - the status text and
+ *  - the created_at timestamp and
+ *  - the status id and
+ *  - the user in a twitter_xml_user struct.
+ */
+static xt_status twitter_xt_get_status( struct xt_node *node, struct twitter_xml_status *txs )
+{
+	struct xt_node *child;
+
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "text", child->name ) == 0)
+		{
+			txs->text = g_memdup( child->text, child->text_len + 1 );
+		}
+		else if (g_strcasecmp( "created_at", child->name ) == 0)
+		{
+			struct tm parsed;
+			
+			/* Very sensitive to changes to the formatting of
+			   this field. :-( Also assumes the timezone used
+			   is UTC since C time handling functions suck. */
+			if( strptime( child->text, "%a %b %d %H:%M:%S %z %Y", &parsed ) != NULL )
+				txs->created_at = mktime_utc( &parsed );
+		}
+		else if (g_strcasecmp( "user", child->name ) == 0)
+		{
+			txs->user = g_new0(struct twitter_xml_user, 1);
+			twitter_xt_get_user( child, txs->user );
+		}
+		else if (g_strcasecmp( "id", child->name ) == 0)
+		{
+			txs->id = g_ascii_strtoull (child->text, NULL, 10);
+		}
+	}
+	return XT_HANDLED;
+}
+
+/**
+ * Function to fill a twitter_xml_list struct.
+ * It sets:
+ *  - all <status>es within the <status> element and
+ *  - the next_cursor.
+ */
+static xt_status twitter_xt_get_status_list( struct xt_node *node, struct twitter_xml_list *txl )
+{
+	struct twitter_xml_status *txs;
+	struct xt_node *child;
+
+	// Set the type of the list.
+	txl->type = TXL_STATUS;
+
+	// The root <statuses> node should hold the list of statuses <status>
+	// Walk over the nodes children.
+	for( child = node->children ; child ; child = child->next )
+	{
+		if ( g_strcasecmp( "status", child->name ) == 0)
+		{
+			txs = g_new0(struct twitter_xml_status, 1);
+			twitter_xt_get_status(child, txs);
+			// Put the item in the front of the list.
+			txl->list = g_slist_prepend (txl->list, txs);
+		}
+		else if ( g_strcasecmp( "next_cursor", child->name ) == 0)
+		{
+			twitter_xt_next_cursor(child, txl);
+		}
+	}
+
+	return XT_HANDLED;
+}
+
+static void twitter_http_get_home_timeline(struct http_request *req);
+
+/**
+ * Get the timeline.
+ */
+void twitter_get_home_timeline(struct im_connection *ic, int next_cursor)
+{
+	struct twitter_data *td = ic->proto_data;
+
+	char* args[4];
+	args[0] = "cursor";
+	args[1] = g_strdup_printf ("%d", next_cursor);
+	if (td->home_timeline_id) {
+		args[2] = "since_id";
+		args[3] = g_strdup_printf ("%llu", (long long unsigned int) td->home_timeline_id);
+	}
+
+	twitter_http(TWITTER_HOME_TIMELINE_URL, twitter_http_get_home_timeline, ic, 0, td->user, td->pass, args, td->home_timeline_id ? 4 : 2);
+
+	g_free(args[1]);
+	if (td->home_timeline_id) {
+		g_free(args[3]);
+	}
+}
+
+/**
+ * Function that is called to see the statuses in a groupchat window.
+ */
+static void twitter_groupchat(struct im_connection *ic, GSList *list)
+{
+	struct twitter_data *td = ic->proto_data;
+	GSList *l = NULL;
+	struct twitter_xml_status *status;
+	struct groupchat *gc;
+
+	// Create a new groupchat if it does not exsist.
+	if (!td->home_timeline_gc)
+	{   
+		char *name_hint = g_strdup_printf( "Twitter_%s", ic->acc->user );
+		td->home_timeline_gc = gc = imcb_chat_new( ic, "home/timeline" );
+		imcb_chat_name_hint( gc, name_hint );
+		g_free( name_hint );
+		// Add the current user to the chat...
+		imcb_chat_add_buddy( gc, ic->acc->user );
+	}
+	else
+	{   
+		gc = td->home_timeline_gc;
+	}
+
+	for ( l = list; l ; l = g_slist_next(l) )
+	{
+		status = l->data;
+		twitter_add_buddy(ic, status->user->screen_name, status->user->name);
+		
+		// Say it!
+		if (g_strcasecmp(td->user, status->user->screen_name) == 0)
+			imcb_chat_log (gc, "Your Tweet: %s", status->text);
+		else
+			imcb_chat_msg (gc, status->user->screen_name, status->text, 0, status->created_at );
+		
+		// Update the home_timeline_id to hold the highest id, so that by the next request
+		// we won't pick up the updates allready in the list.
+		td->home_timeline_id = td->home_timeline_id < status->id ? status->id : td->home_timeline_id;
+	}
+}
+
+/**
+ * Function that is called to see statuses as private messages.
+ */
+static void twitter_private_message_chat(struct im_connection *ic, GSList *list)
+{
+	struct twitter_data *td = ic->proto_data;
+	GSList *l = NULL;
+	struct twitter_xml_status *status;
+	char from[MAX_STRING];
+	gboolean mode_one;
+	
+	mode_one = g_strcasecmp( set_getstr( &ic->acc->set, "mode" ), "one" ) == 0;
+
+	if( mode_one )
+	{
+		g_snprintf( from, sizeof( from ) - 1, "twitter_%s", ic->acc->user );
+		from[MAX_STRING-1] = '\0';
+	}
+	
+	for ( l = list; l ; l = g_slist_next(l) )
+	{
+		char *text = NULL;
+		
+		status = l->data;
+		
+		if( mode_one )
+			text = g_strdup_printf( "\002<\002%s\002>\002 %s",
+			                        status->user->screen_name, status->text );
+		else
+			twitter_add_buddy(ic, status->user->screen_name, status->user->name);
+		
+		imcb_buddy_msg( ic,
+		                mode_one ? from : status->user->screen_name,
+		                mode_one ? text : status->text,
+		                0, status->created_at );
+		
+		// Update the home_timeline_id to hold the highest id, so that by the next request
+		// we won't pick up the updates allready in the list.
+		td->home_timeline_id = td->home_timeline_id < status->id ? status->id : td->home_timeline_id;
+		
+		g_free( text );
+	}
+}
+
+/**
+ * Callback for getting the home timeline.
+ */
+static void twitter_http_get_home_timeline(struct http_request *req)
+{
+	struct im_connection *ic = req->data;
+	struct twitter_data *td;
+	struct xt_parser *parser;
+	struct twitter_xml_list *txl;
+
+	// Check if the connection is still active.
+	if( !g_slist_find( twitter_connections, ic ) )
+		return;
+	
+	td = ic->proto_data;
+
+	// Check if the HTTP request went well.
+	if (req->status_code == 200)
+	{
+		td->http_fails = 0;
+		if (!ic->flags & OPT_LOGGED_IN)
+			imcb_connected(ic);
+	}
+	else if (req->status_code == 401)
+	{
+		imcb_error( ic, "Authentication failure" );
+		imc_logout( ic, FALSE );
+		return;
+	}
+	else
+	{
+		// It didn't go well, output the error and return.
+		if (++td->http_fails >= 5)
+			imcb_error(ic, "Could not retrieve " TWITTER_HOME_TIMELINE_URL ". HTTP STATUS: %d", req->status_code);
+		
+		return;
+	}
+
+	txl = g_new0(struct twitter_xml_list, 1);
+	txl->list = NULL;
+
+	// Parse the data.
+	parser = xt_new( NULL, txl );
+	xt_feed( parser, req->reply_body, req->body_size );
+	// The root <statuses> node should hold the list of statuses <status>
+	twitter_xt_get_status_list(parser->root, txl);
+	xt_free( parser );
+
+	// See if the user wants to see the messages in a groupchat window or as private messages.
+	if (g_strcasecmp(set_getstr(&ic->acc->set, "mode"), "chat") == 0)
+		twitter_groupchat(ic, txl->list);
+	else
+		twitter_private_message_chat(ic, txl->list);
+
+	// Free the structure.	
+	txl_free(txl);
+	g_free(txl);
+}
+
+/**
+ * Callback for getting (twitter)friends...
+ *
+ * Be afraid, be very afraid! This function will potentially add hundreds of "friends". "Who has 
+ * hundreds of friends?" you wonder? You probably not, since you are reading the source of 
+ * BitlBee... Get a life and meet new people!
+ */
+static void twitter_http_get_statuses_friends(struct http_request *req)
+{
+	struct im_connection *ic = req->data;
+	struct twitter_data *td;
+	struct xt_parser *parser;
+	struct twitter_xml_list *txl;
+	GSList *l = NULL;
+	struct twitter_xml_user *user;
+
+	// Check if the connection is still active.
+	if( !g_slist_find( twitter_connections, ic ) )
+		return;
+	
+	td = ic->proto_data;
+	
+	// Check if the HTTP request went well.
+	if (req->status_code != 200) {
+		// It didn't go well, output the error and return.
+		if (++td->http_fails >= 5)
+			imcb_error(ic, "Could not retrieve " TWITTER_SHOW_FRIENDS_URL " HTTP STATUS: %d", req->status_code);
+		
+		return;
+	} else {
+		td->http_fails = 0;
+	}
+
+	txl = g_new0(struct twitter_xml_list, 1);
+	txl->list = NULL;
+
+	// Parse the data.
+	parser = xt_new( NULL, txl );
+	xt_feed( parser, req->reply_body, req->body_size );
+
+	// Get the user list from the parsed xml feed.
+	twitter_xt_get_user_list(parser->root, txl);
+	xt_free( parser );
+
+	// Add the users as buddies.
+	for ( l = txl->list; l ; l = g_slist_next(l) )
+	{
+		user = l->data;
+		twitter_add_buddy(ic, user->screen_name, user->name);
+	}
+
+	// if the next_cursor is set to something bigger then 0 there are more friends to gather.
+	if (txl->next_cursor > 0)
+		twitter_get_statuses_friends(ic, txl->next_cursor);
+
+	// Free the structure.
+	txl_free(txl);
+	g_free(txl);
+}
+
+/**
+ * Get the friends.
+ */
+void twitter_get_statuses_friends(struct im_connection *ic, int next_cursor)
+{
+	struct twitter_data *td = ic->proto_data;
+
+	char* args[2];
+	args[0] = "cursor";
+	args[1] = g_strdup_printf ("%d", next_cursor);
+
+	twitter_http(TWITTER_SHOW_FRIENDS_URL, twitter_http_get_statuses_friends, ic, 0, td->user, td->pass, args, 2);
+
+	g_free(args[1]);
+}
+
+/**
+ * Callback after sending a new update to twitter.
+ */
+static void twitter_http_post_status(struct http_request *req)
+{
+	struct im_connection *ic = req->data;
+
+	// Check if the connection is still active.
+	if( !g_slist_find( twitter_connections, ic ) )
+		return;
+
+	// Check if the HTTP request went well.
+	if (req->status_code != 200) {
+		// It didn't go well, output the error and return.
+		imcb_error(ic, "Could not post message... HTTP STATUS: %d", req->status_code);
+		return;
+	}
+}
+
+/**
+ * Function to POST a new status to twitter.
+ */ 
+void twitter_post_status(struct im_connection *ic, char* msg)
+{
+	struct twitter_data *td = ic->proto_data;
+
+	char* args[2];
+	args[0] = "status";
+	args[1] = msg;
+	twitter_http(TWITTER_STATUS_UPDATE_URL, twitter_http_post_status, ic, 1, td->user, td->pass, args, 2);
+//	g_free(args[1]);
+}
+
+
+/**
+ * Function to POST a new message to twitter.
+ */
+void twitter_direct_messages_new(struct im_connection *ic, char *who, char *msg)
+{
+	struct twitter_data *td = ic->proto_data;
+
+	char* args[4];
+	args[0] = "screen_name";
+	args[1] = who;
+	args[2] = "text";
+	args[3] = msg;
+	// Use the same callback as for twitter_post_status, since it does basically the same.
+	twitter_http(TWITTER_DIRECT_MESSAGES_NEW_URL, twitter_http_post_status, ic, 1, td->user, td->pass, args, 4);
+//	g_free(args[1]);
+//	g_free(args[3]);
+}
Index: protocols/twitter/twitter_lib.h
===================================================================
--- protocols/twitter/twitter_lib.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
+++ protocols/twitter/twitter_lib.h	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -0,0 +1,86 @@
+/***************************************************************************\
+*                                                                           *
+*  BitlBee - An IRC to IM gateway                                           *
+*  Simple module to facilitate twitter functionality.                       *
+*                                                                           *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
+*                                                                           *
+*  This library is free software; you can redistribute it and/or            *
+*  modify it under the terms of the GNU Lesser General Public               *
+*  License as published by the Free Software Foundation, version            *
+*  2.1.                                                                     *
+*                                                                           *
+*  This library is distributed in the hope that it will be useful,          *
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        *
+*  Lesser General Public License for more details.                          *
+*                                                                           *
+*  You should have received a copy of the GNU Lesser General Public License *
+*  along with this library; if not, write to the Free Software Foundation,  *
+*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA           *
+*                                                                           *
+****************************************************************************/
+
+
+#ifndef _TWITTER_LIB_H
+#define _TWITTER_LIB_H
+
+#include "nogaim.h"
+#include "twitter_http.h"
+
+#define TWITTER_API_URL "http://twitter.com"
+
+/* Status URLs */
+#define TWITTER_STATUS_UPDATE_URL TWITTER_API_URL "/statuses/update.xml"
+#define TWITTER_STATUS_SHOW_URL TWITTER_API_URL "/statuses/show/"
+#define TWITTER_STATUS_DESTROY_URL TWITTER_API_URL "/statuses/destroy/"
+
+/* Timeline URLs */
+#define TWITTER_PUBLIC_TIMELINE_URL TWITTER_API_URL "/statuses/public_timeline.xml"
+#define TWITTER_FEATURED_USERS_URL TWITTER_API_URL "/statuses/featured.xml"
+#define TWITTER_FRIENDS_TIMELINE_URL TWITTER_API_URL "/statuses/friends_timeline.xml"
+#define TWITTER_HOME_TIMELINE_URL TWITTER_API_URL "/statuses/home_timeline.xml"
+#define TWITTER_MENTIONS_URL TWITTER_API_URL "/statuses/mentions.xml"
+#define TWITTER_USER_TIMELINE_URL TWITTER_API_URL "/statuses/user_timeline.xml"
+
+/* Users URLs */
+#define TWITTER_SHOW_USERS_URL TWITTER_API_URL "/users/show.xml"
+#define TWITTER_SHOW_FRIENDS_URL TWITTER_API_URL "/statuses/friends.xml"
+#define TWITTER_SHOW_FOLLOWERS_URL TWITTER_API_URL "/statuses/followers.xml"
+
+/* Direct messages URLs */
+#define TWITTER_DIRECT_MESSAGES_URL TWITTER_API_URL "/direct_messages.xml"
+#define TWITTER_DIRECT_MESSAGES_NEW_URL TWITTER_API_URL "/direct_messages/new.xml"
+#define TWITTER_DIRECT_MESSAGES_SENT_URL TWITTER_API_URL "/direct_messages/sent.xml"
+#define TWITTER_DIRECT_MESSAGES_DESTROY_URL TWITTER_API_URL "/direct_messages/destroy/"
+
+/* Friendships URLs */
+#define TWITTER_FRIENDSHIPS_CREATE_URL TWITTER_API_URL "/friendships/create.xml"
+#define TWITTER_FRIENDSHIPS_DESTROY_URL TWITTER_API_URL "/friendships/destroy.xml"
+#define TWITTER_FRIENDSHIPS_SHOW_URL TWITTER_API_URL "/friendships/show.xml"
+
+/* Social graphs URLs */
+#define TWITTER_FRIENDS_IDS_URL TWITTER_API_URL "/friends/ids.xml"
+#define TWITTER_FOLLOWERS_IDS_URL TWITTER_API_URL "/followers/ids.xml"
+
+/* Account URLs */
+#define TWITTER_ACCOUNT_RATE_LIMIT_URL TWITTER_API_URL "/account/rate_limit_status.xml"
+
+/* Favorites URLs */
+#define TWITTER_FAVORITES_GET_URL TWITTER_API_URL "/favorites.xml"
+#define TWITTER_FAVORITE_CREATE_URL TWITTER_API_URL "/favorites/create/"
+#define TWITTER_FAVORITE_DESTROY_URL TWITTER_API_URL "/favorites/destroy/"
+
+/* Block URLs */
+#define TWITTER_BLOCKS_CREATE_URL TWITTER_API_URL "/blocks/create/"
+#define TWITTER_BLOCKS_DESTROY_URL TWITTER_API_URL "/blocks/destroy/"
+
+void twitter_get_friends_ids(struct im_connection *ic, int next_cursor);
+void twitter_get_home_timeline(struct im_connection *ic, int next_cursor);
+void twitter_get_statuses_friends(struct im_connection *ic, int next_cursor);
+
+void twitter_post_status(struct im_connection *ic, char *msg);
+void twitter_direct_messages_new(struct im_connection *ic, char *who, char *message);
+
+#endif //_TWITTER_LIB_H
+
Index: storage_xml.c
===================================================================
--- storage_xml.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ storage_xml.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -496,4 +496,5 @@
 		goto write_error;
 	
+	fsync( fd );
 	close( fd );
 	
Index: unix.c
===================================================================
--- unix.c	(revision b5b40ffd38e315223c6e38e4a291cbd58e471062)
+++ unix.c	(revision ae3dc9996f5a678d6364005cab1517b6324eb67a)
@@ -83,17 +83,20 @@
 	
 		i = bitlbee_inetd_init();
-		log_message( LOGLVL_INFO, "Bitlbee %s starting in inetd mode.", BITLBEE_VERSION );
+		log_message( LOGLVL_INFO, "BitlBee %s starting in inetd mode.", BITLBEE_VERSION );
 
 	}
 	else if( global.conf->runmode == RUNMODE_DAEMON )
 	{
-		log_link( LOGLVL_ERROR, LOGOUTPUT_SYSLOG );
-		log_link( LOGLVL_WARNING, LOGOUTPUT_SYSLOG );
+		log_link( LOGLVL_ERROR, LOGOUTPUT_CONSOLE );
+		log_link( LOGLVL_WARNING, LOGOUTPUT_CONSOLE );
 
 		i = bitlbee_daemon_init();
-		log_message( LOGLVL_INFO, "Bitlbee %s starting in daemon mode.", BITLBEE_VERSION );
+		log_message( LOGLVL_INFO, "BitlBee %s starting in daemon mode.", BITLBEE_VERSION );
 	}
 	else if( global.conf->runmode == RUNMODE_FORKDAEMON )
 	{
+		log_link( LOGLVL_ERROR, LOGOUTPUT_CONSOLE );
+		log_link( LOGLVL_WARNING, LOGOUTPUT_CONSOLE );
+
 		/* In case the operator requests a restart, we need this. */
 		old_cwd = g_malloc( 256 );
@@ -106,5 +109,5 @@
 		
 		i = bitlbee_daemon_init();
-		log_message( LOGLVL_INFO, "Bitlbee %s starting in forking daemon mode.", BITLBEE_VERSION );
+		log_message( LOGLVL_INFO, "BitlBee %s starting in forking daemon mode.", BITLBEE_VERSION );
 	}
 	if( i != 0 )
